﻿Imports ThinkGeo.MapSuite.Core
Imports System.Collections.ObjectModel
Public Class Form1
   Private moSqlLayer As MsSql2008FeatureLayer
   Private moSqlFeatureSource As MsSql2008FeatureSource
   Public Sub New()

      ' This call is required by the designer.
      InitializeComponent()

      ' Add any initialization after the InitializeComponent() call.
      TextBox1.Text = "1. Enter server, database, usename and password. Also provide the name of a table to connect to and the ID field for the table." & vbCrLf &
                      "2. Click the connect button to connect to the server and open the layer." & vbCrLf &
                      "3. Enter a Where clause to apply to the layer, then click 'Apply Where Clause'." & vbCrLf &
                      "4. Enter a query to run against the layer, including an 'ORDER BY'." & vbCrLf &
                      "5. Click 'Execute Query'." & vbCrLf &
                      "6. Observe the SQL sent to the server."
   End Sub
   Private Sub btnConnect_Click(sender As Object, e As System.EventArgs) Handles btnConnect.Click
      Dim oBuilder As New System.Data.SqlClient.SqlConnectionStringBuilder

      If txtServer.Text = String.Empty Then
         Return
      Else
         oBuilder.DataSource = txtServer.Text
      End If
      If txtDatabase.Text = String.Empty Then
         Return
      Else
         oBuilder.InitialCatalog = txtDatabase.Text
      End If

      If txtSpatialView.Text = String.Empty Then
         Return
      End If

      If txtUserName.Text = String.Empty Then
         oBuilder.IntegratedSecurity = True
      Else
         oBuilder.UserID = txtUserName.Text
         If txtPassword.Text = String.Empty Then
            Return
         Else
            oBuilder.Password = txtPassword.Text
         End If
      End If

      If txtColumnName.Text = String.Empty Then
         Return
      End If
      Try
         moSqlLayer = New MsSql2008FeatureLayer(oBuilder.ConnectionString, txtSpatialView.Text, txtColumnName.Text)
         moSqlLayer.Open()
         moSqlFeatureSource = CType(moSqlLayer.FeatureSource, MsSql2008FeatureSource)
         MessageBox.Show("Layer successfully opened!")
      Catch ex As Exception
         Dim sMsg As String = "Exception Thrown:" & vbCrLf & ex.ToString
         MessageBox.Show(sMsg, Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
      End Try

   End Sub

   Private Sub btnApplyWhere_Click(sender As System.Object, e As System.EventArgs) Handles btnApplyWhere.Click
      If Not txtWhereClause.Text = String.Empty Then
         moSqlLayer.Close()
         moSqlLayer.WhereClause = txtWhereClause.Text
         moSqlLayer.Open()
      End If
   End Sub

   Private Sub btnExecute_Click(sender As System.Object, e As System.EventArgs) Handles btnExecute.Click
      txtSqlToServer.Text = ""
      AddHandler moSqlFeatureSource.ExecutingSqlStatement, AddressOf ExecutingSqlStatement
      Try
         Dim oTable As DataTable = moSqlLayer.QueryTools.ExecuteQuery(txtQuery.Text)
      Catch ex As Exception
         MessageBox.Show("ERROR: " & ex.Message, "Test", MessageBoxButtons.OK, MessageBoxIcon.Error)
      End Try
      RemoveHandler moSqlFeatureSource.ExecutingSqlStatement, AddressOf ExecutingSqlStatement
   End Sub

   Private Sub ExecutingSqlStatement(sender As Object, e As ThinkGeo.MapSuite.Core.ExecutingSqlStatementMsSql2008FeatureSourceEventArgs)
      txtSqlToServer.Text += e.SqlStatement
   End Sub
End Class
